/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCIImageRep;

import dwt.internal.cocoa.CIImage;
import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSImageRep;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCIImageRep : NSImageRep
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public CIImage CIImage ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_CIImage);
        return result !is null ? new CIImage(result) : null;
    }

    public static id imageRepWithCIImage (CIImage image)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSCIImageRep, OS.sel_imageRepWithCIImage_1, image !is null ? image.id : null);
        return result !is null ? new id(result) : null;
    }

    public NSCIImageRep initWithCIImage (CIImage image)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithCIImage_1, image !is null ? image.id : null);
        return result !is null ? this : null;
    }

}
