/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSController;

import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSController : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool commitEditing ()
    {
        return OS.objc_msgSend(this.id, OS.sel_commitEditing) !is null;
    }

    public void commitEditingWithDelegate (id delegatee, bool didCommitSelector, void* contextInfo)
    {
        OS.objc_msgSend(this.id, OS.sel_commitEditingWithDelegate_1didCommitSelector_1contextInfo_1, delegatee !is null ? delegatee.id : null,
                didCommitSelector, contextInfo);
    }

    public void discardEditing ()
    {
        OS.objc_msgSend(this.id, OS.sel_discardEditing);
    }

    public bool isEditing ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isEditing) !is null;
    }

    public void objectDidBeginEditing (id editor)
    {
        OS.objc_msgSend(this.id, OS.sel_objectDidBeginEditing_1, editor !is null ? editor.id : null);
    }

    public void objectDidEndEditing (id editor)
    {
        OS.objc_msgSend(this.id, OS.sel_objectDidEndEditing_1, editor !is null ? editor.id : null);
    }

}
