/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCreateCommand;

import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSScriptClassDescription;
import dwt.internal.cocoa.NSScriptCommand;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCreateCommand : NSScriptCommand
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSScriptClassDescription createClassDescription ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_createClassDescription);
        return result !is null ? new NSScriptClassDescription(result) : null;
    }

    public NSDictionary resolvedKeyDictionary ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_resolvedKeyDictionary);
        return result !is null ? new NSDictionary(result) : null;
    }

}
