/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDecimal;

//import dwt.internal.cocoa.OS;
import dwt.internal.cocoa.NSInteger;

struct NSDecimal
{
    uint _exponent;
    uint _length;
    uint _isNegative;
    uint _isCompact;
    uint _reserved;
    /*ushort[OS.NSDecimalMaxSize]*/ushort* _mantissa;
}

enum NSCalculationError : NSUInteger
{
    NSCalculationNoError = 0,
    NSCalculationLossOfPrecision, // Result lost precision
    NSCalculationUnderflow, // Result became 0
    NSCalculationOverflow, // Result exceeds possible representation
    NSCalculationDivideByZero
}

alias NSCalculationError.NSCalculationNoError NSCalculationNoError;
alias NSCalculationError.NSCalculationLossOfPrecision NSCalculationLossOfPrecision;
alias NSCalculationError.NSCalculationUnderflow NSCalculationUnderflow;
alias NSCalculationError.NSCalculationOverflow NSCalculationOverflow;
alias NSCalculationError.NSCalculationDivideByZero NSCalculationDivideByZero;

enum NSRoundingMode : NSUInteger
{
    NSRoundPlain, // Round up on a tie
    NSRoundDown, // Always down == truncate
    NSRoundUp, // Always up
    NSRoundBankers // on a tie round so last digit is even
}

alias NSRoundingMode.NSRoundPlain NSRoundPlain;
alias NSRoundingMode.NSRoundDown NSRoundDown;
alias NSRoundingMode.NSRoundUp NSRoundUp;
alias NSRoundingMode.NSRoundBankers NSRoundBankers;
