/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSFontPanel;

import dwt.internal.cocoa.NSFont;
import dwt.internal.cocoa.NSPanel;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSFontPanel : NSPanel
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSView accessoryView ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_accessoryView);
        return result !is null ? new NSView(result) : null;
    }

    public bool isEnabled ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isEnabled) !is null;
    }

    public NSFont panelConvertFont (NSFont fontObj)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_panelConvertFont_1, fontObj !is null ? fontObj.id : null);
        return result !is null ? new NSFont(result) : null;
    }

    public void reloadDefaultFontFamilies ()
    {
        OS.objc_msgSend(this.id, OS.sel_reloadDefaultFontFamilies);
    }

    public void setAccessoryView (NSView aView)
    {
        OS.objc_msgSend(this.id, OS.sel_setAccessoryView_1, aView !is null ? aView.id : null);
    }

    public void setEnabled (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setEnabled_1, flag);
    }

    public void setPanelFont (NSFont fontObj, bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setPanelFont_1isMultiple_1, fontObj !is null ? fontObj.id : null, flag);
    }

    public static NSFontPanel sharedFontPanel ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSFontPanel, OS.sel_sharedFontPanel);
        return result !is null ? new NSFontPanel(result) : null;
    }

    public static bool sharedFontPanelExists ()
    {
        return OS.objc_msgSend(OS.class_NSFontPanel, OS.sel_sharedFontPanelExists) !is null;
    }

    public bool worksWhenModal ()
    {
        return OS.objc_msgSend(this.id, OS.sel_worksWhenModal) !is null;
    }

}
