/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSHTTPURLResponse;

import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSURLResponse;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSHTTPURLResponse : NSURLResponse
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSDictionary allHeaderFields ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_allHeaderFields);
        return result !is null ? new NSDictionary(result) : null;
    }

    public static NSString localizedStringForStatusCode (NSInteger statusCode)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSHTTPURLResponse, OS.sel_localizedStringForStatusCode_1, statusCode);
        return result !is null ? new NSString(result) : null;
    }

    public NSInteger statusCode ()
    {
        return OS.objc_msgSend(this.id, OS.sel_statusCode);
    }

}
