/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSImageView;

import dwt.internal.cocoa.NSControl;
import dwt.internal.cocoa.NSImage;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSImageView : NSControl
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool allowsCutCopyPaste ()
    {
        return OS.objc_msgSend(this.id, OS.sel_allowsCutCopyPaste) !is null;
    }

    public bool animates ()
    {
        return OS.objc_msgSend(this.id, OS.sel_animates) !is null;
    }

    public NSImage image ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_image);
        return result !is null ? new NSImage(result) : null;
    }

    public NSImageAlignment imageAlignment ()
    {
        return OS.objc_msgSend(this.id, OS.sel_imageAlignment);
    }

    public NSImageFrameStyle imageFrameStyle ()
    {
        return OS.objc_msgSend(this.id, OS.sel_imageFrameStyle);
    }

    public NSImageScaling imageScaling ()
    {
        return OS.objc_msgSend(this.id, OS.sel_imageScaling);
    }

    public bool isEditable ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isEditable) !is null;
    }

    public void setAllowsCutCopyPaste (bool allow)
    {
        OS.objc_msgSend(this.id, OS.sel_setAllowsCutCopyPaste_1, allow);
    }

    public void setAnimates (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setAnimates_1, flag);
    }

    public void setEditable (bool yn)
    {
        OS.objc_msgSend(this.id, OS.sel_setEditable_1, yn);
    }

    public void setImage (NSImage newImage)
    {
        OS.objc_msgSend(this.id, OS.sel_setImage_1, newImage !is null ? newImage.id : null);
    }

    public void setImageAlignment (NSImageAlignment newAlign)
    {
        OS.objc_msgSend(this.id, OS.sel_setImageAlignment_1, newAlign);
    }

    public void setImageFrameStyle (NSImageFrameStyle newStyle)
    {
        OS.objc_msgSend(this.id, OS.sel_setImageFrameStyle_1, newStyle);
    }

    public void setImageScaling (NSImageScaling newScaling)
    {
        OS.objc_msgSend(this.id, OS.sel_setImageScaling_1, newScaling);
    }

}
