/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSLogicalTest;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSScriptWhoseTest;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSLogicalTest : NSScriptWhoseTest
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initAndTestWithTests (NSArray subTests)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initAndTestWithTests_1, subTests !is null ? subTests.id : null);
        return result !is null ? new id(result) : null;
    }

    public id initNotTestWithTest (NSScriptWhoseTest subTest)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initNotTestWithTest_1, subTest !is null ? subTest.id : null);
        return result !is null ? new id(result) : null;
    }

    public id initOrTestWithTests (NSArray subTests)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initOrTestWithTests_1, subTests !is null ? subTests.id : null);
        return result !is null ? new id(result) : null;
    }

}
