/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMethodSignature;

import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMethodSignature : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSUInteger frameLength ()
    {
        return OS.objc_msgSend(this.id, OS.sel_frameLength);
    }

    public /*const*/char* getArgumentTypeAtIndex (NSUInteger idx)
    {
        return OS.objc_msgSend(this.id, OS.sel_getArgumentTypeAtIndex_1, idx);
    }

    public bool isOneway ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isOneway) !is null;
    }

    public NSUInteger methodReturnLength ()
    {
        return OS.objc_msgSend(this.id, OS.sel_methodReturnLength);
    }

    public /*const*/char* methodReturnType ()
    {
        return OS.objc_msgSend(this.id, OS.sel_methodReturnType);
    }

    public NSUInteger numberOfArguments ()
    {
        return OS.objc_msgSend(this.id, OS.sel_numberOfArguments);
    }

    public static NSMethodSignature signatureWithObjCTypes (/*const*/char* types)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSMethodSignature, OS.sel_signatureWithObjCTypes_1, types);
        return result !is null ? new NSMethodSignature(result) : null;
    }

}
