/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSOperationQueue;

import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSOperationQueue : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void addOperation (NSOperation op)
    {
        OS.objc_msgSend(this.id, OS.sel_addOperation_1, op !is null ? op.id : null);
    }

    public void cancelAllOperations ()
    {
        OS.objc_msgSend(this.id, OS.sel_cancelAllOperations);
    }

    public bool isSuspended ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isSuspended) !is null;
    }

    public NSInteger maxConcurrentOperationCount ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_maxConcurrentOperationCount);
    }

    public NSArray operations ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_operations);
        return result !is null ? new NSArray(result) : null;
    }

    public void setMaxConcurrentOperationCount (NSInteger cnt)
    {
        OS.objc_msgSend(this.id, OS.sel_setMaxConcurrentOperationCount_1, cnt);
    }

    public void setSuspended (bool b)
    {
        OS.objc_msgSend(this.id, OS.sel_setSuspended_1, b);
    }

    public void waitUntilAllOperationsAreFinished ()
    {
        OS.objc_msgSend(this.id, OS.sel_waitUntilAllOperationsAreFinished);
    }

}
