/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPanel;

import dwt.internal.cocoa.NSWindow;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPanel : NSWindow
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool becomesKeyOnlyIfNeeded ()
    {
        return OS.objc_msgSend(this.id, OS.sel_becomesKeyOnlyIfNeeded) !is null;
    }

    public bool isFloatingPanel ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isFloatingPanel) !is null;
    }

    public void setBecomesKeyOnlyIfNeeded (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setBecomesKeyOnlyIfNeeded_1, flag);
    }

    public void setFloatingPanel (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setFloatingPanel_1, flag);
    }

    public void setWorksWhenModal (bool flag)
    {
        OS.objc_msgSend(this.id, OS.sel_setWorksWhenModal_1, flag);
    }

    public bool worksWhenModal ()
    {
        return OS.objc_msgSend(this.id, OS.sel_worksWhenModal) !is null;
    }

}
