/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSRangeSpecifier;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSScriptClassDescription;
import dwt.internal.cocoa.NSScriptObjectSpecifier;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSRangeSpecifier : NSScriptObjectSpecifier
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSScriptObjectSpecifier endSpecifier ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_endSpecifier);
        return result !is null ? new NSScriptObjectSpecifier(result) : null;
    }

    public id initWithContainerClassDescription (NSScriptClassDescription classDesc, NSScriptObjectSpecifier container, NSString property,
            NSScriptObjectSpecifier startSpec, NSScriptObjectSpecifier endSpec)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithContainerClassDescription_1containerSpecifier_1key_1startSpecifier_1endSpecifier_1,
                classDesc !is null ? classDesc.id : null, container !is null ? container.id : null, property !is null ? property.id : null,
                startSpec !is null ? startSpec.id : null, endSpec !is null ? endSpec.id : null);
        return result !is null ? new id(result) : null;
    }

    public void setEndSpecifier (NSScriptObjectSpecifier endSpec)
    {
        OS.objc_msgSend(this.id, OS.sel_setEndSpecifier_1, endSpec !is null ? endSpec.id : null);
    }

    public void setStartSpecifier (NSScriptObjectSpecifier startSpec)
    {
        OS.objc_msgSend(this.id, OS.sel_setStartSpecifier_1, startSpec !is null ? startSpec.id : null);
    }

    public NSScriptObjectSpecifier startSpecifier ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_startSpecifier);
        return result !is null ? new NSScriptObjectSpecifier(result) : null;
    }

}
