/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSpellServer;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSSpellServer : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id delegatee ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_delegate);
        return result !is null ? new id(result) : null;
    }

    public bool isWordInUserDictionaries (NSString word, bool flag)
    {
        return OS.objc_msgSend(this.id, OS.sel_isWordInUserDictionaries_1caseSensitive_1, word !is null ? word.id : null, flag) !is null;
    }

    public bool registerLanguage (NSString language, NSString vendor)
    {
        return OS.objc_msgSend(this.id, OS.sel_registerLanguage_1byVendor_1, language !is null ? language.id : null,
                vendor !is null ? vendor.id : null) !is null;
    }

    public void run ()
    {
        OS.objc_msgSend(this.id, OS.sel_run);
    }

    public void setDelegate (id anObject)
    {
        OS.objc_msgSend(this.id, OS.sel_setDelegate_1, anObject !is null ? anObject.id : null);
    }

}
