/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSStepperCell;

import dwt.internal.cocoa.NSActionCell;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSStepperCell : NSActionCell
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool autorepeat ()
    {
        return OS.objc_msgSend(this.id, OS.sel_autorepeat) !is null;
    }

    public double increment ()
    {
        return OS.objc_msgSend_fpret(this.id, OS.sel_increment);
    }

    public double maxValue ()
    {
        return OS.objc_msgSend_fpret(this.id, OS.sel_maxValue);
    }

    public double minValue ()
    {
        return OS.objc_msgSend_fpret(this.id, OS.sel_minValue);
    }

    public void setAutorepeat (bool autorepeat)
    {
        OS.objc_msgSend(this.id, OS.sel_setAutorepeat_1, autorepeat);
    }

    public void setIncrement (double increment)
    {
        OS.objc_msgSend(this.id, OS.sel_setIncrement_1, increment);
    }

    public void setMaxValue (double maxValue)
    {
        OS.objc_msgSend(this.id, OS.sel_setMaxValue_1, maxValue);
    }

    public void setMinValue (double minValue)
    {
        OS.objc_msgSend(this.id, OS.sel_setMinValue_1, minValue);
    }

    public void setValueWraps (bool valueWraps)
    {
        OS.objc_msgSend(this.id, OS.sel_setValueWraps_1, valueWraps);
    }

    public bool valueWraps ()
    {
        return OS.objc_msgSend(this.id, OS.sel_valueWraps) !is null;
    }

}
