/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSTextTableBlock;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSTextBlock;
import dwt.internal.cocoa.NSTextTable;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSTextTableBlock : NSTextBlock
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSInteger columnSpan ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_columnSpan);
    }

    public id initWithTable (NSTextTable table, NSInteger row, NSInteger rowSpan, NSInteger col, NSInteger colSpan)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithTable_1startingRow_1rowSpan_1startingColumn_1columnSpan_1,
                table !is null ? table.id : null, row, rowSpan, col, colSpan);
        return result !is null ? new id(result) : null;
    }

    public NSInteger rowSpan ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_rowSpan);
    }

    public NSInteger startingColumn ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_startingColumn);
    }

    public NSInteger startingRow ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_startingRow);
    }

    public NSTextTable table ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_table);
        return result !is null ? new NSTextTable(result) : null;
    }

}
