/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSURLResponse;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSURL;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSURLResponse : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSString MIMEType ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_MIMEType);
        return result !is null ? new NSString(result) : null;
    }

    public NSURL URL ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_URL);
        return result !is null ? new NSURL(result) : null;
    }

    public long expectedContentLength ()
    {
        return cast(long) OS.objc_msgSend(this.id, OS.sel_expectedContentLength);
    }

    public id initWithURL (NSURL URL, NSString MIMEType, NSInteger length, NSString name)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithURL_1MIMEType_1expectedContentLength_1textEncodingName_1,
                URL !is null ? URL.id : null, MIMEType !is null ? MIMEType.id : null, length, name !is null ? name.id : null);
        return result !is null ? new id(result) : null;
    }

    public NSString suggestedFilename ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_suggestedFilename);
        return result !is null ? new NSString(result) : null;
    }

    public NSString textEncodingName ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_textEncodingName);
        return result !is null ? new NSString(result) : null;
    }

}
